searchData={"items":[{"type":"module","title":"PolymorphicEmbed","doc":"","ref":"PolymorphicEmbed.html"},{"type":"function","title":"PolymorphicEmbed.cast_polymorphic_embed/3","doc":"","ref":"PolymorphicEmbed.html#cast_polymorphic_embed/3"},{"type":"function","title":"PolymorphicEmbed.do_load/3","doc":"","ref":"PolymorphicEmbed.html#do_load/3"},{"type":"function","title":"PolymorphicEmbed.get_polymorphic_module/3","doc":"","ref":"PolymorphicEmbed.html#get_polymorphic_module/3"},{"type":"function","title":"PolymorphicEmbed.get_polymorphic_type/3","doc":"","ref":"PolymorphicEmbed.html#get_polymorphic_type/3"},{"type":"macro","title":"PolymorphicEmbed.polymorphic_embeds_many/2","doc":"","ref":"PolymorphicEmbed.html#polymorphic_embeds_many/2"},{"type":"macro","title":"PolymorphicEmbed.polymorphic_embeds_one/2","doc":"","ref":"PolymorphicEmbed.html#polymorphic_embeds_one/2"},{"type":"function","title":"PolymorphicEmbed.traverse_errors/2","doc":"","ref":"PolymorphicEmbed.html#traverse_errors/2"},{"type":"function","title":"PolymorphicEmbed.types/2","doc":"Returns the possible types for a given schema and field\n\nyou can call `types/2` like this:\n    PolymorphicEmbed.types(MySchema, :contexts)\n    #=> [:location, :age, :device]","ref":"PolymorphicEmbed.html#types/2"},{"type":"module","title":"PolymorphicEmbed.HTML.Form","doc":"","ref":"PolymorphicEmbed.HTML.Form.html"},{"type":"function","title":"PolymorphicEmbed.HTML.Form.get_polymorphic_type/2","doc":"","ref":"PolymorphicEmbed.HTML.Form.html#get_polymorphic_type/2"},{"type":"function","title":"PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/2","doc":"Generates a new form builder without an anonymous function.\n\nSimilarly to `Phoenix.HTML.Form.inputs_for/3`, this function exists for\nintegration with `Phoenix.LiveView`.\n\nUnlike `polymorphic_embed_inputs_for/4`, this function does not generate\nhidden inputs.","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/2"},{"type":"function","title":"Example - PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/2","doc":"<.form\n      :let={f}\n      for={@changeset}\n      id=\"reminder-form\"\n      phx-change=\"validate\"\n      phx-submit=\"save\"\n    >\n      <%= for channel_form <- polymorphic_embed_inputs_for f, :channel do %>\n        <%= hidden_inputs_for(channel_form) %>\n\n        <%= case get_polymorphic_type(reminder_form, Reminder, :channel) do %>\n          <% :sms -> %>\n            <%= label channel_form, :number %>\n            <%= text_input channel_form, :number %>\n\n          <% :email -> %>\n            <%= label channel_form, :email %>\n            <%= text_input channel_form, :email %>\n      <% end %>\n    </.form>","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/2-example"},{"type":"function","title":"PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/3","doc":"Like `polymorphic_embed_inputs_for/4`, but determines the type from the\nform data.","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/3"},{"type":"function","title":"Example - PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/3","doc":"<%= inputs_for f, :reminders, fn reminder_form -> %>\n      <%= polymorphic_embed_inputs_for reminder_form, :channel, fn channel_form -> %>\n        <%= case get_polymorphic_type(reminder_form, Reminder, :channel) do %>\n          <% :sms -> %>\n            <%= label poly_form, :number %>\n            <%= text_input poly_form, :number %>\n\n          <% :email -> %>\n            <%= label poly_form, :email %>\n            <%= text_input poly_form, :email %>\n        <% end %>\n      <% end %>\n    <% end %>\n\nWhile `polymorphic_embed_inputs_for/4` renders empty fields if the data is\n`nil`, this function does not. Instead, you can initialize your changeset\nto render an empty fieldset:\n\n    changeset = reminder_changeset(\n      %Reminder{},\n      %{\"channel\" => %{\"__type__\" => \"sms\"}}\n    )","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/3-example"},{"type":"function","title":"PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/4","doc":"","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/4"},{"type":"function","title":"PolymorphicEmbed.HTML.Form.to_form/4","doc":"","ref":"PolymorphicEmbed.HTML.Form.html#to_form/4"},{"type":"module","title":"PolymorphicEmbed.HTML.Helpers","doc":"","ref":"PolymorphicEmbed.HTML.Helpers.html"},{"type":"function","title":"PolymorphicEmbed.HTML.Helpers.get_polymorphic_type/2","doc":"Returns the polymorphic type of the given field in the given form data.","ref":"PolymorphicEmbed.HTML.Helpers.html#get_polymorphic_type/2"},{"type":"function","title":"PolymorphicEmbed.HTML.Helpers.to_form/4","doc":"","ref":"PolymorphicEmbed.HTML.Helpers.html#to_form/4"},{"type":"extras","title":"Polymorphic embeds for Ecto","doc":"# Polymorphic embeds for Ecto\n\n`polymorphic_embed` brings support for polymorphic/dynamic embedded schemas in Ecto.\n\nEcto's `embeds_one` and `embeds_many` macros require a specific schema module to be specified. This library removes this restriction by\n**dynamically** determining which schema to use, based on data to be stored (from a form or API) and retrieved (from the\ndata source).","ref":"readme.html"},{"type":"extras","title":"Usage - Polymorphic embeds for Ecto","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Enable polymorphism - Polymorphic embeds for Ecto","doc":"Let's say we want a schema `Reminder` representing a reminder for an event, that can be sent either by email or SMS.\n\nWe create the `Email` and `SMS` embedded schemas containing the fields that are specific for each of those communication\nchannels.\n\nThe `Reminder` schema can then contain a `:channel` field that will either hold an `Email` or `SMS` struct, by setting\nits type to the custom type `PolymorphicEmbed` that this library provides.\n\nFind the schema code and explanations below.\n\n```elixir\ndefmodule MyApp.Reminder do\n  use Ecto.Schema\n  import Ecto.Changeset\n  import PolymorphicEmbed\n\n  schema \"reminders\" do\n    field :date, :utc_datetime\n    field :text, :string\n\n    polymorphic_embeds_one :channel,\n      types: [\n        sms: MyApp.Channel.SMS,\n        email: MyApp.Channel.Email\n      ],\n      on_type_not_found: :raise,\n      on_replace: :update\n  end\n\n  def changeset(struct, values) do\n    struct\n    |> cast(values, [:date, :text])\n    |> cast_polymorphic_embed(:channel, required: true)\n    |> validate_required(:date)\n  end\nend\n```\n\n```elixir\ndefmodule MyApp.Channel.Email do\n  use Ecto.Schema\n  import Ecto.Changeset\n\n  @primary_key false\n\n  embedded_schema do\n    field :address, :string\n    field :confirmed, :boolean\n  end\n\n  def changeset(email, params) do\n    email\n    |> cast(params, [:address, :confirmed])\n    |> validate_required(:address)\n    |> validate_length(:address, min: 4)\n  end\nend\n```\n\n```elixir\ndefmodule MyApp.Channel.SMS do\n  use Ecto.Schema\n  import Ecto.Changeset\n\n  @primary_key false\n\n  embedded_schema do\n    field :number, :string\n  end\n\n  def changeset(sms, params) do\n    sms\n    |> cast(params, [:number])\n    |> validate_required(:number)\n  end\nend\n```\n\nIn your migration file, you may use the type `:map` for both `polymorphic_embeds_one/2` and `polymorphic_embeds_many/2` fields.\n\n```elixir\nadd(:channel, :map)\n```\n\n[It is not recommended](https://hexdocs.pm/ecto/3.11.2/Ecto.Schema.html#embeds_many/3) to use `{:array, :map}` for a list of embeds.\n\n### `cast_polymorphic_embed/3`\n\n`cast_polymorphic_embed/3` must be called to cast the polymorphic embed's parameters.\n\n#### Options\n\n* `:required` – if the embed is a required field.\n\n* `:with` – allows you to specify a custom changeset.\n```elixir\nchangeset\n|> cast_polymorphic_embed(:channel,\n  with: [\n    sms: &SMS.custom_changeset/2,\n    email: &Email.custom_changeset/2\n  ]\n)\n```","ref":"readme.html#enable-polymorphism"},{"type":"extras","title":"PolymorphicEmbed Ecto type - Polymorphic embeds for Ecto","doc":"The `:types` option for the `PolymorphicEmbed` custom type contains a keyword list mapping an atom representing the type\n(in this example `:email` and `:sms`) with the corresponding embedded schema module.\n\nThere are two strategies to detect the right embedded schema to use:\n\n1.\n```elixir\n[sms: MyApp.Channel.SMS]\n```\n\nWhen receiving parameters to be casted (e.g. from a form), we expect a `\"__type__\"` (or `:__type__`) parameter\ncontaining the type of channel (`\"email\"` or `\"sms\"`).\n\n2.\n```elixir\n[email: [\n  module: MyApp.Channel.Email,\n  identify_by_fields: [:address, :confirmed]]]\n```\n\nHere we specify how the type can be determined based on the presence of given fields. In this example, if the data\ncontains `:address` and `:confirmed` parameters (or their string version), the type is `:email`. A `\"__type__\"`\nparameter is then no longer required.\n\nNote that you may still include a `__type__` parameter that will take precedence over this strategy (this could still be\nuseful if you need to store incomplete data, which might not allow identifying the type).\n\n#### List of polymorphic embeds\n\nLists of polymorphic embeds are also supported:\n\n```elixir\npolymorphic_embeds_many :contexts,\n  types: [\n    location: MyApp.Context.Location,\n    age: MyApp.Context.Age,\n    device: MyApp.Context.Device\n  ],\n  on_type_not_found: :raise,\n  on_replace: :delete\n```\n\n#### Options\n\n* `:types` – discussed above.\n* `:type_field` – specify a custom type field. Defaults to `:__type__`.\n* `:on_type_not_found` – specify what to do if the embed's type cannot be inferred.\n  Possible values are\n  - `:raise`: raise an error\n  - `:changeset_error`: add a changeset error\n  - `:nilify`: replace the data by `nil`; only for single (non-list) embeds\n  - `:ignore`: ignore the data; only for lists of embeds\n\n  By default, a changeset error \"is invalid\" is added.\n* `:on_replace` – mandatory option that can only be set to `:update` for a single embed and `:delete` for a list of\n  embeds (we force a value as the default value of this option for `embeds_one` and `embeds_many` is `:raise`).","ref":"readme.html#polymorphicembed-ecto-type"},{"type":"extras","title":"Displaying form inputs and errors in Phoenix templates - Polymorphic embeds for Ecto","doc":"The library comes with a form helper in order to build form inputs for polymorphic embeds and display changeset errors.\n\nIn the entrypoint defining your web interface (`lib/your_app_web.ex` file), add the following import, change `view` to the one your component use, ex. `liew_view`:\n\n```elixir\ndef view do\n  quote do\n    # imports and stuff\n    import PolymorphicEmbed.HTML.Form\n  end\nend\n```\n\nThis provides you with the `polymorphic_embed_inputs_for/3` and `polymorphic_embed_inputs_for/4` functions.\n\nHere is an example form using the imported function:\n\n```elixir\n<%= inputs_for f, :reminders, fn reminder_form -> %>\n  <%= polymorphic_embed_inputs_for reminder_form, :channel, :sms, fn sms_form -> %>\n     \n       Number \n      <%= text_input sms_form, :number %>\n       \n        <%= error_tag sms_form, :number %>\n       \n     \n  <% end %>\n<% end %>\n```\n\nWhen using `polymorphic_embed_inputs_for/4`, you have to manually specify the type. When the embed is `nil`, empty fields will be displayed.\n\n`polymorphic_embed_inputs_for/3` doesn't require the type to be specified. When the embed is `nil`, no fields are displayed.\n\nThey both render a hidden input for the `\"__type__\"` field.","ref":"readme.html#displaying-form-inputs-and-errors-in-phoenix-templates"},{"type":"extras","title":"Displaying form inputs and errors in LiveView - Polymorphic embeds for Ecto","doc":"You may use `polymorphic_embed_inputs_for/2` when working with LiveView.\n\n```elixir\n<.form\n  :let={f}\n  for={@changeset}\n  id=\"reminder-form\"\n  phx-change=\"validate\"\n  phx-submit=\"save\"\n>\n  <%= for channel_form <- polymorphic_embed_inputs_for f, :channel do %>\n    <%= hidden_inputs_for(channel_form) %>\n\n    <%= case get_polymorphic_type(f, :channel) do %>\n      <% :sms -> %>\n        <%= label channel_form, :number %>\n        <%= text_input channel_form, :number %>\n\n      <% :email -> %>\n        <%= label channel_form, :email_address %>\n        <%= text_input channel_form, :adress %>\n    <% end %>\n  <% end %>\n</.form>\n```\n\nUsing this function, you have to render the necessary hidden inputs manually as shown above.","ref":"readme.html#displaying-form-inputs-and-errors-in-liveview"},{"type":"extras","title":"Get the type of a polymorphic embed - Polymorphic embeds for Ecto","doc":"Sometimes you need to serialize the polymorphic embed and, once in the front-end, need to distinguish them.\n`PolymorphicEmbed.get_polymorphic_type/3` returns the type of the polymorphic embed:\n\n```elixir\nPolymorphicEmbed.get_polymorphic_type(Reminder, :channel, SMS) == :sms\n```\n\n### `traverse_errors/2`\n\nThe function `Ecto.changeset.traverse_errors/2` won't include the errors of polymorphic embeds. You may instead use `PolymorphicEmbed.traverse_errors/2` when working with polymorphic embeds.","ref":"readme.html#get-the-type-of-a-polymorphic-embed"},{"type":"extras","title":"Features - Polymorphic embeds for Ecto","doc":"* Detect which types to use for the data being `cast`-ed, based on fields present in the data (no need for a *type* field in the data)\n* Run changeset validations when a `changeset/2` function is present (when absent, the library will introspect the fields to cast)\n* Support for nested polymorphic embeds\n* Support for nested `embeds_one`/`embeds_many` embeds\n* Display form inputs for polymorphic embeds in Phoenix templates\n* Tests to ensure code quality","ref":"readme.html#features"},{"type":"extras","title":"Installation - Polymorphic embeds for Ecto","doc":"Add `polymorphic_embed` for Elixir as a dependency in your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:polymorphic_embed, \"~> 4.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"HexDocs - Polymorphic embeds for Ecto","doc":"HexDocs documentation can be found at [https://hexdocs.pm/polymorphic_embed](https://hexdocs.pm/polymorphic_embed).","ref":"readme.html#hexdocs"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}